*-- Liststru - Stand alone version of list structure program
*--	to be run from foxpro window on currently open tables
*--
*-- 09/13/2002 - CVG - Added routine to check for and open all dbfs in subdir
*-- 09/26/2002 - CVG - Add flag/routine to save records in table (ListRecs)
*-- 10/20/2002 - CVG - Add form for driving this
*PARAMETERS llrecords, lnRecords, lcDir

llRecords = .f.
lnRecords = 0
lcDir = ""
llRunIt = .f.

*-- Get subdir, save records flag and count
lcSaveHeight = _Screen.Height
lcSaveWidth  = _Screen.Width
do form liststru
if ! llRunIt
	*-- Cancel in form, yes just quit
	_Screen.Height = lcSaveHeight
	_Screen.Width  = lcSaveWidth
	return
endif

*-- Generic output file
GCOUTPUT = "liststru.lst"

*-- Go to subdir
lcThisDir = sys(5) + curdir()
set default to &lcDir.

*-- Create an empty workfile
if used('liststru')
	use in liststru
endif
do l_erase with "liststru.dbf"
do l_erase with "liststru.ftp"
do l_erase with "liststru.cdx"
do l_erase with "listrecs.dbf"
do l_erase with "listrecs.ftp"
do l_erase with "listrecs.cdx"
create table liststru (;
        FIELD_NAME C(60), ;  
        FIELD_TYPE C(1), ;  
        FIELD_LEN N(3), ; 
        FIELD_DEC N(3), ; 
        TABLE_NAME C(60), ;   
        ALIAS C(30), ;
        DBF M(4), ;
        CDX M(4), ;
        FULLFILE C(240))
index on table_name tag table_name
lcdrive = SYS(5)

*-- Save contents?
IF llrecords
	CREATE TABLE listrecs (;
		table_name C(60), ;
		records m)
ENDIF

*-- Open all tables in subdirectory
WAIT WINDOW "Open all files in "+lcDir NOWAIT
do ListOpen

*-- Fill array of select areas with
*--		Files open in them
WAIT WINDOW "Process Structures to ListStru" NOWAIT
lnx = 0
FOR ii = 1 TO 225
  alis = STR(ii)
  SELECT &alis
  IF ! EMPTY(ALIAS()) 		AND ;
  	 ALIAS() <> "LISTSTRU"	AND ;
  	 ALIAS() <> "LISTLIST"	AND ;
  	 ALIAS() <> "LISTRECS"  AND ;
  	 ALIAS() <> "AC_ERRORS" and ;
  	 alias() <> "FOXUSER"
    lnx = lnx + 1
    DIMENSION lasels(lnx)
    lasels(lnx) = alis
  ENDIF
ENDFOR

*-- Any Files open?
IF lnx = 0
  =MESSAGEBOX("No files open, cannot list structures", 64)
  RETURN
ENDIF

*-- Fill Work file with Structures
FOR ii = 1 TO ALEN(lasels)
  if empty(lasels(ii))
    loop
  endif
  alis = lasels(ii)
  SELECT &alis

  lcalis = ALIAS()
  lcfnam = DBF()
  lctabl = strtran(alltrim(right(lcfnam, len(lcfnam)-rat("\",lcfnam))), '.DBF','')
  lccnam = STRTRAN(CDX(1), lcdrive, "")
  lctemp = SYS(3)

  *-- Saving records?
  IF llRecords
  	SELECT (lcalis)
  	IF RECCOUNT() > 0
		lnMemoWidth = SET('memowidth')
		SET MEMOWIDTH TO 1024
		IF TYPE('lnRecords') = "N"
			GO top
			LIST to FILE junk nocon next (lnrecords)
		ELSE
		  	LIST to FILE junk nocon
		ENDIF
		SET MEMOWIDTH TO (lnMemoWidth)

	  	SELECT listrecs
	  	APPEND BLANK
	  	replace table_name WITH lcTabl
	  	APPEND MEMO records FROM junk.txt
	  	ERASE junk.txt
		SELECT (lcalis)
	ENDIF
  ENDIF

  *-- Now work with the structure  
  COPY STRUCTURE EXTENDED TO &lctemp.

  SELECT liststru
  lnlast = RECCOUNT()

  *-- Add structure for this file
  APPEND FROM &lctemp.
  ERASE &lctemp..DBF
  IF FILE("&lctemp..fpt")
    ERASE &lctemp..fpt
  ENDIF
  
  *-- Update fields for table
  GOTO lnlast + 1
  *  lctable = IIF(EMPTY(table_name), lcalis, table_name)
  REPLACE alias WITH lcalis, ;
  		  dbf   WITH lcfnam, ;
  		  cdx	WITH lccnam, ;
  		  table_name WITH lctabl ;
  	  FOR RECNO() > lnlast
  
  *-- Now add key information
  SELECT &alis
  llfirst = .T.
  FOR nn = 1 TO 100
    IF EMPTY(tag(nn))
      EXIT
    ENDIF
    lctag = TAG(nn)
    lckey = KEY(nn)
    SELECT liststru
    APPEND BLANK
    IF llfirst
      llfirst = .F.
      REPLACE field_name WITH "Index:", ;
		      alias WITH lcalis, ;
  			  dbf   WITH lcfnam, ;
  			  cdx	WITH lccnam, ;
  			  table_name WITH lctabl
      APPEND BLANK
    ENDIF
    REPLACE field_name 	WITH "  " + ALLTRIM(lctag) + ": " + lckey, ;
		    alias 		WITH lcalis, ;
  			dbf   		WITH lcfnam, ;
  			cdx	  		WITH lccnam, ;
  			table_name 	WITH lctabl
    SELECT &alis
  ENDFOR
ENDFOR

SELECT liststru
replace all fullfile with dbf
lcrepfile = "liststru"

*-- Go Back to calling subdir
set default to &lcThisDir.

_Screen.Height = lcSaveHeight
_Screen.Width  = lcSaveWidth

if messagebox("Preview Report Now?", 36) = 6
	REPORT FORM liststru PREVIEW
endif

RETURN


*-- *******************
*-- Field Type Function
FUNCTION l_fieldtype

DO CASE
  CASE field_type = "C"
	lcretn = "Character"
  CASE field_type = "D"
    lcretn = "Date"
  CASE field_type = "N"
	lcretn = "Numeric"
  CASE field_type = "I"
	lcretn = "Integer"
  CASE field_type = "L"
	lcretn = "Logical"
  CASE field_type = "M"
	lcretn = "Memo"
  CASE field_type = "T"
	lcretn = "DateTime"
  CASE field_type = "Y"
	lcretn = "Currency"
  CASE field_type = "F"
	lcretn = "Float"
  CASE field_type = "B"
	lcretn = "Double"
  CASE field_type = "G"
	lcretn = "General"
  CASE field_type = " "
    lcretn = "Key"
  OTHERWISE
    lcretn = "Unknown"
ENDCASE	

RETURN (lcretn)

*-- ***********************************
*-- Log error when file can't be opened
procedure l_badfile

ON ERROR
llerr = .t.
lcalias = alias()
wait window "error opening " + lcfname nowait

IF ! USED("ac_errors")
  create cursor ac_errors (filename C(240), error C(80))
endif

select ac_errors
append blank
replace filename with lcfname, ;
		error	 with alltrim(str(error())) + " - " + message()

if ! empty(lcalias)
  select (lcalias)
endif

on error do l_badfile

return

*-- ****************
*-- ****************
*--	protected erase!
procedure l_erase
parameter lcFile

if file(lcFile)
	erase (lcFile)
endif

return


*-- *******************************
*-- Open all dbfs in current subdir
procedure listopen

=adir(latemp, "*.DBF")
for lnx = 1 TO alen(latemp, 1)
	lcFile = alltrim(latemp(lnx, 1))
	if lcFile <> "LISTSTRU"		and ;
	   lcFile <> "LISTRECS"		AND ;
	   lcFile <> "FOXUSER"
		use &lcFile. in 0
	endif
endfor

release latemp

return
