*-- chkbld
*--
*--	Build work file for processing
*-- 	Customize this for any repository of ASCII filenames
*--		Return with chkstr process format (see help) 
*--
*-- If called with a VFP project filename, fill from project
if upper(right(alltrim(gcfname),4)) == '.PJX'
	*-- Open Project file
	use (gHomeDir+gcfname) alias project in 0
	select project
	*-- Find the home directory
	locate for type == 'H'
	gHomeDir = alltrim(iif(found(), chrtran(homedir, chr(0), ""), ""))
	gHomeDir = gHomeDir + iif(empty(gHomeDir), '', '\')
	*-- Load file with objects to scan
	scan for type!='H' and type < 'Z'
		append blank in ac_files
		cFilename = alltrim(chrtran(strtran(project.name, ".mnx", ".mpr"), chr(0), ""))
		replace ;
			ac_files.filename with cFileName, ;
			ac_files.type 	  with type, ;
			ac_files.source   with .f.
	endscan
	use in project
else
	*-- Fill from ASCII text file
	*-- Fill intermediate file first
	create cursor ac_temp (type C(1), filename C(254))
	append from (gHomeDir+gcfname) sdf

	*-- Do we have a Home Directory record in text file
	locate for type == "H"
	if found()
		*-- Replace Default home directory
		gHomeDir = iif(found(), alltrim(filename), "")
		gHomeDir = gHomeDir + iif(empty(gHomeDir), '', ;
			iif(right(gHomeDir, 1) <> '\', '\', ""))
		delete for type == "H"
	endif

	*-- Now load up filename cursor from temp file
	scan for ! empty(type)
		select ac_files
		append blank
		replace type     with ac_temp.type, ;
				filename with ac_temp.filename, ;
				source	 with .f.
		select ac_temp
	endscan
	use in ac_temp
endif

return
