*-- Browse List of Searches
*-- Create cursor for User's Desires
lcalis = ALIAS()
SELECT *, ;
	   .F.		  AS delt, ;
	   .F.		  AS view, ;
	   .F.		  AS source, ;
	   SPACE(60)  AS texts, ;
	   SPACE(120) AS filename ;
  FROM chkstrin ;
 ORDER BY rptfile ;
  INTO CURSOR ac_tmpr
=AFIELDS(latemp)
CREATE CURSOR ac_cstrin FROM ARRAY latemp
APPEND FROM DBF("ac_tmpr")
USE IN ac_tmpr

REPLACE ALL texts    WITH text, ;
		    filename WITH ALLTRIM(homedir) + ;
		    		      ALLTRIM(fname)
go bottom

*-- Get option(s).  Will do first of each then quit?
lcSaveEsc = on('key', 'ESC')
on key label escape
on key label F10 keyboard chr(23)
BROWSE FIELDS view	   :h="View?"   :P="Y", ;
			  source   :h="Source?" :P="Y", ;
			  delt     :h="Remove?" :P="Y", ;
			  rptfile  :h="Srch" :R, ;
			  datetime :h="Date" :R, ;
			  texts    :h="String" :R :30, ;
			  filename :h="Run On File" :R ;
	    TITLE "Select Searches to View/Re-Print/Remove - F10 to Execute, <Esc> to Cancel"
on key label escape &lcSaveEsc
on key label F10

*-- Escape?  Just quit
if lastkey() = 27
	use in ac_cstrin
	llRetn=.t.
	return
endif

*-- ************************
*-- View Searches?  (Browse)
*-- ************************
select ac_cstrin.*, ;
	   left("ChkRept" + ;
	   		alltrim(str(ac_cstrin.rptfile))+space(3), 10) ;
	     as outfile ;
  from ac_cstrin ;
 where view ;
 order by rptfile ;
  into cursor ac_tmpr
=afields(latemp)
create cursor ac_vDrive from array latemp
append from dbf('ac_tmpr')

*-- Get number of reports selected
select rptfile from ac_vDrive ;
 order by rptfile ;
 group by rptfile ;
  into cursor ac_junk
lnRptCount = reccount()
use in ac_junk
lnSequence = 0

*-- Any to view?
select ac_vDrive
go top
do while ! eof()
	lnSequence = lnSequence + 1
	*-- Have chosen files to view, setup
	lnReport = rptfile
	do l_view
	if used('ac_text')
		do form chkView
		use in ac_text
	endif
	if used('ac_view')
		use in ac_view
	endif
	*-- Any More?
	select ac_vDrive
	delete for rptfile = lnReport
	go top
enddo
use in ac_vDrive

*-- *******************
*-- View Source Files?
*-- *******************
select ac_cstrin.*, ;
	   left("ChkRept" + ;
	   		alltrim(str(ac_cstrin.rptfile))+space(3), 10) ;
	     as outfile ;
  from ac_cstrin ;
 where source ;
 order by rptfile ;
  into cursor ac_tmpr
=afields(latemp)
create cursor ac_vDrive from array latemp
append from dbf('ac_tmpr')

*-- Get number of reports selected
select rptfile from ac_vDrive ;
 order by rptfile ;
 group by rptfile ;
  into cursor ac_junk
lnRptCount = reccount()
use in ac_junk
lnSequence = 0

*-- Any to view Source?
select ac_vDrive
go top
do while ! eof()
	lnSequence = lnSequence + 1
	*-- Have chosen files to view, setup
	lnReport = rptfile
	if file("chksave"+alltrim(str(rptfile))+".dbf")
		*-- Have chosen Source files to view, setup
		do l_view
		if used('ac_text')
			do chkview3
			do form chkView4
			use in ac_text
		endif
		if used('ac_view')
			use in ac_view
		endif
	else
		=messagebox("Sorry, You didn't save source with this search." + chr(13) + ;
					"Search Number " + alltrim(str(lnReport)), 16)
	endif
	*-- Any more?
	select ac_vDrive
	delete for rptfile = lnReport
	go top
enddo
use in ac_vDrive

*-- *******************
*-- Searches to Delete?
*-- *******************
SELECT rptfile FROM ac_cstrin ;
 WHERE delt ;
 ORDER BY rptfile ;
  INTO CURSOR ac_delt

*-- Yes, delete some
IF ! EOF()
  lnans = MESSAGEBOX("Are you sure you want to delete these searches.", gnyesno+gnquestion)
  IF lnans = 6
    INDEX ON rptfile TAG rptfile
    SELECT chkstrin
    USE chkstrin EXCLUSIVE
    SET RELATION TO rptfile INTO ac_delt
    DELETE FOR ! EMPTY(ac_delt.rptfile)
    PACK

    *-- Delete Report Files (And save files if any)
    SELECT ac_delt
    SCAN
    	for lnx = 1 to 2
    		lcFile = iif(lnx=1, "chkrept", "chksave") + ;
					 	 ALLTRIM(STR(rptfile))
			if Used(lcFile)
			  	use in (lcFile)
			endif
			if file(lcFile + '.dbf')
				ERASE &lcfile..dbf
			endif
			if file(lcFile + '.fpt')
				ERASE &lcfile..fpt
			endif
		endfor
    ENDSCAN

	** Renumber the Searches
	SELECT rptfile FROM chkstrin ;
	 ORDER BY rptfile ;
	 GROUP BY rptfile ;
	  INTO CURSOR ac_renum

	SCAN
	  lnnew = RECNO()
	  SELECT chkstrin
	  REPLACE rptfile WITH lnnew FOR rptfile = ac_renum.rptfile
	  *-- Rename the ChkRept files
	  lcfrom = "chkrept"+ALLTRIM(STR(ac_renum.rptfile))
	  lcto   = "chkrept"+ALLTRIM(STR(lnnew))
	  lcff = lcfrom + ".dbf"
	  IF FILE("&lcff")
	    RENAME &lcfrom..dbf TO &lcto..dbf
	    RENAME &lcfrom..fpt TO &lcto..fpt
	  ENDIF
	  *-- Now do the save source files
	  lcfrom = "chksave"+ALLTRIM(STR(ac_renum.rptfile))
	  lcto   = "chksave"+ALLTRIM(STR(lnnew))
	  lcff = lcfrom + ".dbf"
	  IF FILE("&lcff")
	    RENAME &lcfrom..dbf TO &lcto..dbf
	    RENAME &lcfrom..fpt TO &lcto..fpt
	  ENDIF
	  SELECT ac_renum
	ENDSCAN

    USE IN ac_renum
  ENDIF
ENDIF

USE IN ac_delt
USE IN ac_cstrin
