*-- *********************************
*-- 	 CHKSTR Procedures File
*-- *********************************

*-- ***********************
*-- ***********************
*-- CHECK FILES FOR STRINGS
*-- ***********************
*-- ***********************

*-- ***********************
*-- Scan .SCX - Screen File
procedure l_scanscx

select 0
*-- Error opening file?
IF l_usefile(lcFile)
	RETURN
ENDIF

scan for ! empty(objname) or ;
		 ! empty(methods) or ;
		 ! empty(properties)

	*-- Save Object Name
	lcobj = iif(empty(objname), " **Empty**", alltrim(objname))

	*-- Check in the properties
	if ! empty(properties)
		lnRecno = recno()
		lcname = lcobj + "-Properties"
		for lnx = 1 to memlines(properties)
			lctest = mline(properties, lnx)
			*-- Save all Source Code?
			IF glSaveSource
				=savecode(lcFile, lcName, lcTest)
			ENDIF
			*-- Check for Strings
			do l_chkstrings with lctest, "add_rept WITH lcfile, lnx, lctext, lcname, lnRecno"
		endfor
	endif

	*-- Check in the methods
	if ! empty(methods)
		lnRecno = recno()
		lcnam = lcobj + "-Methods"
		for lnx = 1 to memlines(methods)
			lcStr  = mline(methods, lnx)
			lctest = alltrim(lcStr)
			if left(upper(lctest), 10) = "PROCEDURE "
				*-- Save procedure name
				lcproc = alltrim(right(lctest, len(lctest) - 9))
			endif
			lcname = lcnam + " " + lcproc
			*-- Save all Source Code?
			IF glSaveSource
				=savecode(lcFile, lcName, lcStr)
			ENDIF
			*-- Check for Strings
			do l_chkstrings with lctest, "add_rept WITH lcfile, lnx, lctext, lcname, lnRecno"
		ENDFOR
	ENDIF
ENDSCAN

USE
RETURN

*-- **********************************
*-- Scan M - Misc file with memo field
procedure l_scanmisc

external array lcMField

lnfld = alen(lcMField)

*-- Use file
select 0
*-- Error opening file?
IF l_usefile(lcFile)
	RETURN
ENDIF

*-- Don't Process if don't have fieldname in table
=afields(latemp)
dimension llagot(lnfld)

*-- For Each Field to check
for lnnnz = 1 to lnfld
	llgotit = .f.
	lcfield = alltrim(lcMField(lnnnz))
	*-- For Each field in the record
	for lnnnx = 1 to alen(latemp, 1)
		if (! glCase and upper(trim(latemp(lnnnx,1))) == upper(trim(lcfield)) )  or ;
				(  glCase and trim(latemp(lnnnx,1)) == trim(lcfield) )
			llgotit = .t.
			exit
		endif
	endfor
	llagot(lnnnz) = llgotit
endfor
release latemp

llgotit = .f.
*-- See if we've got ONE
for lnnnz = 1 to lnfld
	if llagot(lnnnz) = .t.
		llgotit = .t.
		exit
	endif
endfor

*-- Have any field name to check
if llGotit
	lcrecs = alltrim(str(reccount()))
	scan
		lnRecno = recno()
		*-- for each field
		for lnnnz = 1 to lnfld
			if ! llagot(lnnnz)
				loop
			endif

			lcfield = alltrim(lcMField(lnnnz))
			if mod(recno(), 10) = 0
				wait window "Chk " + lcfile + "-" + lcfield + chr(13) + ;
					" Rec: " + alltrim(str(recno())) + " of " + lcrecs nowait
			endif

			*-- Save Object Name (fieldname)
			lcobj  = alltrim(str(recno()))+":"
			lcname = lcObj + lcField

			*-- Check the field
			for lnx = 1 to memlines(&lcField)
				lctest = mline(&lcField, lnx)
				do l_chkstrings with lctest, "add_rept WITH lcfile, lnx, lctext, lcname, lnRecno"
			endfor
		endfor
	endscan
endif
use

return

*-- ***********************
*-- Scan .FRX - Report file
*-- Scan .LBX - Label file
procedure l_scanfrx

*-- Make this work for Foxpro 2.6 labels conditional expression
supexpr = ""

*-- Open report or label file
select 0
*-- Error opening file?
IF l_usefile(lcFile)
	RETURN
ENDIF

scan for objtype > 1 and ;
		(! empty(expr) or ! empty(supexpr))
	lnRecno = recno()
	*-- First Expression (field/expr being printed)
	for lnx = 1 to memlines(expr)
		lctest = mline(expr, lnx)
		lcfldn = "Type: " + alltrim(str(objtype)) + " Fld: " + alltrim(str(recno())) + " Field"
		*-- Save all Source Code?
		IF glSaveSource
			=savecode(lcFile, lcFldn, lcTest)
		ENDIF
		*-- Check for Strings
		do l_chkstrings with lctest, "add_rept WITH lcfile, lnx, lctext, lcfldn, lnRecno"
	endfor

	*-- Next, Conditional Expression (Print When Condition is True)
	for lnx = 1 to memlines(supexpr)
		lctest = mline(supexpr, lnx)
		lcfldn = "Type: " + alltrim(str(objtype)) + " Fld: " + alltrim(str(recno())) + " Print When"
		*-- Save all Source Code?
		IF glSaveSource
			=savecode(lcFile, lcFldn, lcTest)
		ENDIF
		*-- Check for Strings
		do l_chkstrings with lctest, "add_rept WITH lcfile, lnx, lctext, lcfldn, lnRecno"
	endfor
endscan

use
return

*-- *********************
*-- Scan .MPR - Menu File
procedure l_scanmpr

select 0
lcfn = left(lcfile, at(".", lcfile) - 1) + ".MNX"
IF FILE(lcfn)
	lcFile = lcfn
	*-- Error opening file?
	IF l_usefile(lcFile)
		RETURN
	ENDIF
*	USE (lcFile) share

	SCAN
		lnRecno  = recno()
		lcPrompt = ALLTRIM(levelname)

		*-- Check all objects in menu record
		if ! empty(Prompt)
			lcObj = "Prompt"
			do scanit with "Prompt"
		ENDIF
		if ! empty(Command)
			lcObj = "Command"
			do scanit with "Command"
		ENDIF
		if ! empty(Message)
			lcObj = "Message"
			do scanit with "Message"
		ENDIF
		if ! empty(Procedure)
			lcObj = "Procedure"
			do scanit with "Procedure"
		ENDIF
		if ! empty(Setup)
			lcObj = "Setup"
			do scanit with "Setup"
		ENDIF
		if ! empty(Cleanup)
			lcObj = "Cleanup"
			do scanit with "Cleanup"
		ENDIF
		IF ! empty(SkipFor)
			lcObj = "SkipFor"
			do scanit with "SkipFor"
		ENDIF
	ENDSCAN
	USE
	*-- Change name to .mnx file!
ELSE
	*-- Scan .mpr file as ascii
	IF FILE(lcFile)
		DO l_scanprg
	ENDIF
ENDIF

return

*-- *********************************************
*-- .PRG/.SPR - Scan Programs or 2.6 Screen Files
*-- This version scans a memo field
procedure scanit
parameter lcfld

for lnx = 1 to memlines(&lcfld.)
	lctest = mline(&lcfld., lnx)
	*-- Save all Source Code?
	IF glSaveSource
		=savecode(lcFile, "", lcTest)
	ENDIF
	*-- Check for Strings
	do l_chkstrings with lctest, "add_rept WITH lcfile, lnx, lcText, lcprompt + ': ' + lcObj, lnRecno"
endfor

return

*-- *******************************************
*-- Scan .PRG - Program file or Flat ASCII File
procedure l_scanprg

create cursor ac_temp (text C(254))
append from (lcfile) sdf

scan
	if ! empty(text)
		lnrc = recno()
		*-- Save all Source Code?
		IF glSaveSource
			=savecode(lcFile, "", Text)
		ENDIF
		*-- Check for Strings
		do l_chkstrings with text, "add_rept WITH lcfile, lnrc, lctext"
	endif
endscan
use in ac_temp

return

*-- ***************************
*-- Scan a .VCX - Class Library
procedure l_scanvcx

*-- Fill work cursor with contents of classlib
create cursor ac_vcx (;
	class M, ;
	classloc M, ;
	baseclass M, ;
	objname M, ;
	parent M, ;
	properties M, ;
	methods M, ;
	cls C(40), ;
	clsloc C(80), ;
	clsbase C(20), ;
	obj C(80), ;
	pop C(80))

append from (lcfile)

*-- Get these "in the clear"
replace all cls 	with alltrim(class), ;
			clsloc 	with alltrim(classloc), ;
			clsbase with alltrim(baseclass), ;
			obj		with alltrim(objname), ;
			pop		with alltrim(parent)

*-- Delete for not relevant
delete for empty(cls+clsloc+clsbase+pop)

*-- Index in form + control order
index on iif(empty(pop), obj, pop) + ;
	iif(clsbase="form", " ", "X") + ;
	upper(obj) ;
	tag popobj

scan for ! empty(methods) or ;
		 ! empty(properties)
	lnRecno = recno()
	lcname = ;
		alltrim(obj) + ;
		iif(! empty(pop), " of "+alltrim(pop), "")+": Type: " + ;
		alltrim(clsbase) + " " + ;
		iif(empty(cls+clsloc), "", ;
		alltrim(cls) + iif(empty(clsloc), "", " in " + alltrim(clsloc)))

	*-- Check in the properties
	lcobj = "-Properties"
	for lnx = 1 to memlines(properties)
		lctest = mline(properties, lnx)
		*-- Save all Source Code?
		IF glSaveSource
			=savecode(lcFile, lcName+lcObj, lcTest)
		ENDIF
		*-- Check for Strings
		do l_chkstrings with lctest, "add_rept WITH lcfile, lnx, lctext, lcname, lnRecno"
	endfor

	*-- Check in the methods
	lcobject = IIF(!EMPTY(pop), ALLTRIM(pop)+".", "")+ALLTRIM(obj)+"-Methods"
	lnlastline = memlines(methods)
	for lnx = 1 to memlines(methods)
		if mod(lnx, 10) = 0
			wait window "Checking " + lcfile + " " + alltrim(obj) + " Methods" + chr(13) + ;
				alltrim(str(lnx)) + ' of ' + alltrim(str(lnlastline)) ;
				nowait
		endif
		lcStr  = mline(methods, lnx)
		lctest = alltrim(lcStr)
		if left(upper(lctest), 10) = "PROCEDURE "
			*-- Save procedure name
			lcproc = alltrim(right(lctest, len(lctest) - 9))
		endif
		lcobj = lcobject + " " + lcproc
		IF glSaveSource
			=SaveCode(lcFile, lcObj, lcStr)
		ENDIF
		do l_chkstrings with lctest, "add_rept WITH lcfile, lnx, lctext, lcname, lnRecno"
	endfor

	select ac_vcx
endscan

use in ac_vcx

return

*-- ********************************************
*-- ********************************************
*-- ************** L_CHKSTRINGS ****************
*-- Check the strings in the array vs. this text
*--	 DO &lcadd string when/if found
procedure l_chkstrings
parameter lctext, lcadd

if empty(lctext)
	return
else
	if glCase
		lctext = alltrim(lctext)
	else
		lctext = alltrim(upper(lctext))
	endif
endif

*-- Are we losing the comments?
lccomm=""
if ! glcomment
	*-- Check for * as first character in string
	lcdoubleamph = chr(38) + chr(38)
	for lnz = 1 to len(lctext)
		lcchar = substr(lctext, lnz, 1)
		*-- If not tab character
		if lcChar <> chr(9)
			lccchk = lcchar+iif(lnz<>len(lctext), substr(lctext, lnz+1), " ")
			if lccchk = lcdoubleamph
				*-- In-Line Comment?  Save it and strip it for check
				lccomm = right(lctext, len(lctext) - lnz)
				lctext = left(lctext, at(lccchk, lctext)-1)
				lcadd = strtran(lcadd, "lctext", "lctext + lccomm")
				exit
			endif

			*-- Check for beginning of line comment
			if lcchar <> " "
				*-- Beginning of Line comment, just leave!
				if lcchar = "*"
					return
				endif
				exit
			endif
		endif
	endfor
endif

*-- Now check for string (or strings) in text
for lnz = 1 to lnstr
	*-- Now check string
	if lcst(lnz) $ lctext
		*-- If counting occurences, do it
		IF glOccurences
			lcTxt = lcText
			gnOcc = 0
			*-- For each occurence
			DO WHILE ! EMPTY(lcTxt)
				lnAt = AT(lcst(lnz), lcTxt)
				if lnAt > 0
					*-- Keep count, cut off string
					gnOcc = gnOcc + 1
					lcTxt = RIGHT(lcTxt, LEN(lcTxt)-lnAt-LEN(lcSt(lnz)))
				ELSE
					*-- No more occurences, leave loop
					lcTxt = ""
				ENDIF
			ENDDO
		ENDIF

		*-- If highlighting string(s) in result
		IF glHighLight
			*-- "Highlight" string searched for
			lctext = lower(lctext)
			lctext = strtran(lctext, lower(lcst(lnz)), upper(lcst(lnz)))
		ENDIF
		DO &lcadd.
	ENDIF
ENDFOR

RETURN

*-- *****************************
*-- Add one record to report file
procedure add_rept
parameters lcf, lnn, lct, lco, lrno

if parameters() < 5
	lrno = 0
endif
if parameters() < 4
	lco = ""
endif

lcalis = alias()

select ac_report
append blank
replace filename with lcf, ;
	lineno	 with str(lnn, len(lineno)), ;
	text	 with lct, ;
	object   with lco, ;
	recno	 with lrno, ;
	string	 with lcst(lnz)

IF glOccurences
	replace count WITH gnOcc
ENDIF

*-- Set found in file flag on
glFoundString = .T.

select (lcalis)

return

*-- *****************************
*-- At end, locate on output file
procedure l_locate

for lnx = 1 to 100
	select (lnx)
	if left(alias(), 7) = "CHKREPT"
		exit
	endif
endfor

return

*-- ********************************
*-- ********** SAVE SOURCE *********
*-- If needed, table for Source code
*-- ********************************
*-- ********************************
procedure ChkSaveSource

*-- Not saving source, just return
if ! glSaveSource
	return
endif

*-- Save selected table
lnSel = select()

*-- Set Found string in file flag off before scanning
glFoundString = .f.	

*-- Select Source Files to save from?
if glSelSource
	*-- Yes, get user input, which files
	glSaveSource = .f.					&& Set flag = not saving any source

	*-- Select list for browse
	select source, ;
		   left(alltrim(filename)+space(12), 120) as file, ;
		   recno() as recno ;
	  from ac_files ;
	  into cursor ac_tmpr
	*-- Make it read/write
	=afields(latemp)
	create cursor ac_source from array latemp
	append from dbf('ac_tmpr')
	use in ac_tmpr
	release latemp

	on key label CTRL+A do l_SetAll		&& Set Ctrl-a = toggle all on/off

	*-- Get operator's desire
	browse fields source :H="Include" :P="Y", ;
				  file   :H="File" :R ;
		noappend nodelete PREFERENCE ac_source ;
		title "Include Source Code - <Esc> to continue, <Ctrl>A Set/Unset All"
	on key label CTRL+A

	*-- Set source flag in ac_files according to selected
	scan for source
		lnRec = recno
		select ac_files
		goto (lnRec)
		replace source with .t.
		select ac_source
		glSaveSource = .t.
	endscan
	use in ac_source

	*-- Is the user still saving any source Files
	if ! glSaveSource
		*-- No, changed their mind
		*-- Change this search's parameters
		*-- to Don't Save Source.
		if ! used('chkstrin')
			use chkstrin in 0
		endif
		select chkstrin
		locate for rptFile = gnnextrept
		replace SaveSource with glSaveSource, ;
				SaveFound  with gnSaveFound
		use in chkstrin
	endif
else
	*-- Default is save all
	select ac_files
	replace all source with .t.
endif

*-- Return to selected table
select (lnSel)

return

*-- *********************************
*-- Toggle select all and select none
*--		in Save Source Browse
procedure l_SetAll

lnRec = recno()
locate for source
if found()
	replace all source with .f.
else
	replace all source with .t.
endif

goto (lnRec)

return

*-- *****************************
*-- Save code for further perusal
*-- *****************************
PROCEDURE savecode
PARAMETERS tcFile, tcObject, tcText

lnSel = SELECT()

*-- Has File been opened yet?
if ! used(gcSaveCodIn)
	*-- No, Make sure of name
	gcSaveCodIn = strtran(gcoutfile, "ChkRept", "ChkSave")
	*-- Open file to save Source Code
	IF USED(gcSaveCodIn)
		USE IN (gcSaveCodIn)
	ENDIF
	*-- Erase, Create table
	ERASE (gcSaveCodIn + ".dbf")
	ERASE (gcSaveCodIn + ".fpt")
	ERASE (gcSaveCodIn + ".cdx")
	CREATE TABLE &gcSaveCodIn. (;
		filename M, ;
		object M, ;
		text M)

	*-- Save only ones where string was found?
	if gnSaveFound = 1
		*-- Create Temp cursor for code
		CREATE cursor ac_SaveCodIn (;
			filename M, ;
			object M, ;
			text M)
		append blank
	endif
endif

*-- Add this source statement
*-- In either final file or temp cursor
if gnSaveFound=1
	select ac_SaveCodIn
else
	SELECT (gcSaveCodIn)
endif

*-- Have this object yet?
IF tcFile   <> gcSaveFile OR ;
   tcObject <> gcSaveObj

	*-- If only saving found, save now if found string
	if gnSaveFound=1
		if glFoundString
			*-- Add this object's source record
			*--  to Final Source Table
			scatter memvar memo
			select (gcSaveCodIn)
			append blank
			gather memvar memo
			select ac_SaveCodIn
		endif
		*-- Blank this Temp Cursor record
		replace text with ""
		*-- Set found in file flag off
		glFoundString = .f.	
	else
		*-- Add a record to the main file
		append blank
	endif

    *-- Add a new record's key info
	replace filename WITH tcFile, ;
			object	 WITH tcObject

	*-- Save key info
	gcSaveFile = tcFile
	gcSaveObj  = tcObject
ENDIF

*-- Add this line of source to the memo field in the table
replace text WITH RTRIM(text) + ;
				  iif(empty(text), "", gcCrLf) + ;
				  RTRIM(tcText)

SELECT (lnSel)

RETURN

*-- *********************************
*-- Fill parameters from Default File
*-- *********************************
procedure l_parafill

if ! used('chkdef')
	use ChkDef in 0
endif
select ChkDef
gcfname = iif(empty(filename), "ChkStr.Txt", alltrim(filename))
gHomeDir = iif(empty(homedir), alltrim(curdir()), alltrim(homedir))
lcChk = gHomeDir + gcFname
if ! file(lcChk)
	if ! file("ChkStr.Txt")
		lh=fcreate("ChkStr.Txt")
		=fputs(lh, "H")
		=fclose(lh)
	endif
	gcfname = "ChkStr.Txt"
	gHomeDir = sys(5) + curdir()
endif	
glreport = report
gnnextrept= chknxtr()
gcoutfile = iif(gcoutfile<>"chkstr.lst", "ChkRept"+alltrim(str(gnnextrept)), gcoutfile)
gcSaveCodIn = strtran(gcoutfile, "ChkRept", "ChkSave")
glwait = WaitWind
glcomment = comment
glclasses = classes
glMaxFrame = maxframe
gcVersion = version
gcCopyRight = Copyright
gnorder = order
gllist = justlist
glCase = case
glAscii = ascii
glHighLight = highlight
*-- For saving sourcecode
glSaveSource = savesource
gnSaveFound  = savefound
glSelSource  = iif(savefound=1, .f., .t.)

use in ChkDef

gcinfo = iif(gllist, "Will output result to ChkStr.Lst, No Report", ;
	"Write Output to " + gcoutfile + " -- " + ;
	iif(glreport, "Will Prompt for Report", "Won't Prompt for Report"))

return


*-- ***********************
*-- Protected USE/Use In
*-- ***********************
PROCEDURE g_use
PARAMETERS tcFile, tcOrder, tlClose, tlExclusive

*-- Just use in?
IF tlClose
	IF USED(tcFile)
		USE IN (tcFile)
	ENDIF
	lRetn = .t.
ELSE
	lRetn = g_use(tcFile, tcOrder, tlExclusive)
ENDIF

RETURN (lRetn)

*-- ********************************
*-- Provisional Open -
*--		If not open already, open it
*-- 	Return with table selected
*--
*-- tcTable = table name
*-- tcTag   = Tag to set (or "" for none)
*--	tcExcl  = .t. open exclusive
PROCEDURE g_open
PARAMETERS tcTable, tcTag, tcExcl

gnAns = 6
lnTryCount = 0

*-- Set error trap for opening
lcError = ON('error')
ON ERROR DO l_cantget with ERROR(), PROGRAM(), MESSAGE()

*-- As long as they want to retry
DO WHILE gnAns = 6
	lnTryCount = lnTryCount + 1
	IF USED(tcTable)
		IF tcExcl
			*-- Going to open exclusive, close it
			USE IN (tcTable)
		ELSE
			*-- Going to select it standard, just return
			SELECT (tcTable)
			IF ! EMPTY(tcTag)
				SET ORDER TO &tcTag.
			ENDIF
			ON ERROR &lcError.
			RETURN (.T.)
		ENDIF
	ENDIF

	*-- Try to open in new workarea
	SELECT 0
	IF tcExcl
		USE (tcTable) EXCLUSIVE
	ELSE
		USE (tcTable)
	ENDIF

	*-- Succeeded, return .t., reset error
	IF USED(tcTable)
		IF ! EMPTY(tcTag)
			SET ORDER TO &tcTag.
		ENDIF
		ON ERROR &lcError.
		RETURN (.T.)
	ENDIF
ENDDO

*-- Gave up, reset error, return .f.
ON ERROR &lcError.

RETURN (.F.)

*-- ******************************
*-- Can't get exclusive use or
*-- Someone else has exclusive use
PROCEDURE l_cantget
PARAMETERS lnError, lcProgram, lcMessage

IF tcExcl
	lcMessage = "Cannot get exclusive use of " + ALLTRIM(tcTable) + CHR(13) + ;
		"Try to get other users to leave the system."
ELSE
	lcMessage = "Someone else has exclusive use of " + ALLTRIM(tcTable) + CHR(13) + ;
		"you cannot continue at this time."
ENDIF

gnAns = MESSAGEBOX(lcMessage + CHR(13) + CHR(13) + ;
	IIF(lnTryCount=1,"Retry?", ;
	"Tried " + ALLTRIM(STR(lnTryCount)) + ;
	" times, try again?"), 20)

RETURN

*-- *********************************
*-- Clean up files - CVG - 10/14/2002
*-- *********************************
procedure l_cleanup

lny=0
for lnx = 1 to 20
	select (lnx)
	if ! left(alias(), 7) $ "CHKREPT|CHKSAVE"
		use
	else
		lny = iif(lny=0, lnx, lny)
	endif
endfor

*-- Release Esc Key
ON KEY LABEL ESC

return

*-- **************************************
*-- 	Adjust strings into test array
*-- **************************************
procedure l_adjstr

lnlen = alen(lastring)
dimension lcst(lnlen)

for lnz = 1 to alen(lastring)
	if glCase
		*-- Preserve Case, just trim
		lcst(lnz) = alltrim(lastring(lnz))
	else
		*-- Don't Preserve Case (default)
		lcst(lnz) = alltrim(upper(lastring(lnz)))
	endif
	if glAscii
		*-- ASCII - Convert <xx> to AScii Equiv.
		lcst(lnz) = l_trxchr(lcst(lnz))
	endif
endfor

return


*-- *************************
*-- *************************
*-- l_usefile - protected use
*--		CVG - 7/9/2003
PROCEDURE l_usefile
PARAMETERS tcFile

lcError = ON("ERROR")
ON ERROR do l_errtrap
llErr = .f.

USE (tcFile) SHARED

ON ERROR &lcError.

RETURN (llErr)

*-- *************************
*-- *************************
PROCEDURE l_errtrap

llErr = .t.
ON ERROR 
=AERROR(gaError)
select ac_report
append blank
replace filename with lcfile, ;
		text	 with gaError(2)

RETURN
