*-- Build cursors for the replace function
lcOutFile = alltrim(ac_view.outfile)
if ! used(lcOutFile)
	use (lcOutFile) in 0
endif

*-- **************************
*-- Cursor for global replaces
select string, ;
	   space(120) as newstring, ;
	   0000000000 as replaces ;
  from (lcOutFile) ;
 order by string ;
 group by string ;
  into cursor ac_tmpr
=afields(latemp)
create cursor ac_replace from array latemp
append from dbf('ac_tmpr')
go top

*-- ********************************
*-- Selector for line level replaces
select fname, ;
	   space(1) as filename, ;	
	   object, ;
	   lineno, ;
	   text, ;
	   string, ;
	   .F. as replflag, ;
	   space(120) as newstring, ;
	   recno()    as Chkrecno ;
  from (lcOutFile) ;
  into cursor ac_tmpr
=afields(latemp)

*-- Get max length for filenames
lnLen = 0
scan
	lcTest = alltrim(right(fname, len(fname) - rat('\', fname)))
	if len(lcTest) > lnLen
		lnLen = len(lcTest)
	endif
endscan
*-- Reset field length
latemp(2, 3) = lnLen
create cursor ac_report from array latemp
append from dbf('ac_tmpr')
replace all filename with alltrim(right(lower(fname), len(fname) - rat('\', fname)))
index on fname tag fname
go top

*-- Close chkRept file
use in (lcOutFile)

*-- ********************************
*-- Selector for File Level replaces
select fname, ;
	   .T. as replflag ;
  from ac_report ;
 order by fname ;
 group by fname ;
  into cursor ac_tmpr
=afields(latemp)
create cursor ac_fname from array latemp
append from dbf('ac_tmpr')
release latemp
use in ac_tmpr
set relation to fname into ac_report
go top

*-- Do the replace form - Backup old is the default
llBackup = .t.
do form chkrepl

if used('ac_replace')
	use in ac_replace
endif
if used('ac_report')
	use in ac_report
endif
if used('ac_fname')
	use in ac_fname
endif

return
