*-- Replace Selected
parameter llValidate

lnSel = select()
select ac_report

if llValidate
	*-- Verify that they want to do this
	push key
	on key label F10 keyboard chr(23)
	on key label esc
	browse fields ;
		replflag  :H="Repl" 		:P="Y", ;
		filename  :H="File" 		:R, ;
		object    :H="Object" 		:R, ;
		lineno    :H="Line" 		:R, ;
		text      :H="Source" 		:R, ;
		string    :H="Chg From" 	:R, ;
		newstring :H="To String" 	:R ;
		noappend nodelete ;
		title "Replace Selected?  F10=Run Replace  <Esc>=Cancel Replace"
	pop key
	
	if lastkey() <> 23
	    wait window "Replace Cancelled" nowait
	    select (lnSel)
		return (.f.)
	endif
endif

*-- Now do the replaces where requested

*-- ******** TEST TEST TEST ********
*-- ******** TEST TEST TEST ********
*=MESSAGEBOX("WARNING: This option has not been 100% tested" + CHR(13) + CHR(13) + ;
*			  "It's currently nulled out.  You may reactivate it" + CHR(13) + ;
*			  "in source (chkview.scx) but test it first!", 16)
*RETURN
*-- ******** TEST TEST TEST ********
*-- ******** TEST TEST TEST ********

*-- Select the ones to be updated
SELECT ac_report.*, ;
	   datetime() as replaced, ;
	   0000000000 as objrec ;
  from ac_report ;
 where replflag ;
 order by fname, object, lineno ;
  into cursor ac_utmpr
=AFIELDS(latemp)
CREATE CURSOR ac_Updated FROM ARRAY latemp
APPEND FROM DBF('ac_utmpr')
USE IN ac_utmpr
RELEASE latemp

*-- If nothing select, don't replace
IF EOF()
	WAIT WINDOW "Nothing to Selected for Replacement" nowait
	USE IN ac_updated
	RETURN
ENDIF

*-- Index ac_updated
INDEX ON fname + object TAG fobj

*-- Create backup subdirectory?
lcBackDir = ""
=l_makebak(llBackup)

*-- Save Update file in Backup Sub for re-run
lcRptNo   = ALLTRIM(STR(lnReport))
lcChkRepl = lcBackDir + "chkRepl" + lcRptNo
llSaveIt = .t.
IF FILE(lcChkRepl + '.dbf')
	llSaveIt = (MESSAGEBOX("You already have a replace session saved." + CHR(13) + ;
						   "Do you want to replace it with this one?", 36) = 6)
ENDIF
IF llSaveIt	
	SELECT ac_report
	COPY TO (lcChkRepl)
	SELECT ac_updated
ENDIF

*-- Open chkreptxx for Object Record Numbers
lcRptFile = "chkRept" + lcRptNo
IF ! USED(lcRptFile)
	USE (lcRptFile) IN 0
ENDIF

*-- Create work file for Update
create cursor ac_work (text M, newText M)
append blank

*-- Create Linkage to Object Record Numbers
SELECT RECNO() 	as rrec, ;
	   recno 	as objrec ;
  FROM (lcRptFile) ;
 WHERE &lcRptFile..recno <> 0 ;
  INTO CURSOR ac_objrec
INDEX ON STR(rrec, 10) TAG rrec

SELECT ac_updated
SET RELATION TO STR(chkrecno,10) INTO ac_objrec
REPLACE ALL objrec WITH ac_objrec.objrec
USE IN ac_objrec
INDEX ON fname+STR(objrec, 10)+object TAG driver

*-- Create table to drive replacements
SELECT fname ;
  FROM ac_updated ;
 ORDER BY fname ;
 GROUP BY fname ;
  INTO CURSOR ac_files

*-- Scan through ac_files cursor to do the updates
lcLastFile = " "		&& Save object file name
scan
	lcFile = alltrim(fname)
	wait window "Update " + lcfile nowait
	lcToFile = STRTRAN(LOWER(ALLTRIM(fname)), ;
			   		   LOWER(ALLTRIM((gHomeDir))),lcBackDir)		

	*-- What type of processing?
	llAscii   = l_objType(alltrim(fname))
	IF llAscii
		*-- Process an Ascii File
		DO l_ReplAscii
	ELSE
		*-- No, Process a file with objects
		DO l_ReplObject
	ENDIF

	SELECT ac_files
ENDSCAN

*-- Make sure last object File is closed
USE IN SELECT("ObjectFile")

*-- If any updated, save information about 'em
select ac_updated
if reccount() <> 0
	*-- Use ChkReptxx file
	lcOutfile = alltrim(ac_view.outfile)
	if ! used(lcOutFile)
		use (lcOutfile) in 0
	endif

	*-- Update in chkReptxx file
	scan
		lnRec = ChkRecno
		lcStr = lower(alltrim(string))
		lcTo  = upper(alltrim(newstring))
		select (lcOutFile)
		goto lnRec
		replace text   with strtran(lower(text), lcStr, lcTo), ;
				string with lcTo
		select ac_updated
	endscan
	use in SELECT(lcOutFile)
		
	*-- Save updated in Save file
	lcSaveRepl = strtran(lcOutfile, "ChkRept", "ChkRepl")
	if file(lcSaveRepl)
		*-- Already have it, append to it
		select 0
		use (lcSaveRepl)
		append from dbf('ac_updated')
		use in (lcSaveRepl)
	else
		*-- Copy to it
		copy to (lcSaveRepl)
	endif
endif
use in ac_updated

Select (lnSel)

return (.t.)

*-- ****************************************
*-- ****************************************
*-- Do all of the replaces in one ascii file		
PROCEDURE l_ReplAscii

*-- Select work file, and append program
SELECT ac_work
GOTO 1
replace newtext WITH "", ;
		text	WITH ""
append memo text from (lcFile) overwrite
lnLineNo = 0

*-- Back it up?
if llBackup
	copy file &lcFile. to &lcToFile.
endif

*-- Run strings for this file
SELECT ac_updated
SCAN FOR fname = lcFile
	lcString  = alltrim(string)
	lnString  = len(lcString)
	lcTo      = alltrim(newstring)
	lnTo	  = len(lcTo)
	lnLine    = val(lineno)
	wait window "Update " + lcFile nowait

	DO l_replone WITH 1
ENDSCAN

*-- Copy the rest to ac_work.newtext
*--				from ac_work.text
DO l_replone WITH 2

*-- Write out replaced file
COPY MEMO newtext TO (lcFile)

RETURN

*-- ************************************
*-- Copy from text to NewText in ac_work
*-- For one replacement string or rest
PROCEDURE l_replone
PARAMETERS tcWhich

IF tcWhich = 1
	*-- If ascii, copy lines up to change
	select ac_work
	lnLineNo = lnLineNo + 1
	for lnx = lnLineNo TO (lnLine - 1)
		replace newText with ;
			rtrim(newText) + ;
			iif(lnx<>1, chr(13), '') + ;
			mline(text, lnx)
	endfor

	*-- Now replace in this line
	lcRepl = mline(text, lnLine)
	lcStr  = substr(lcRepl, at(upper(lcString), upper(lcRepl)), lnString)
	lcRepl = strtran(lcRepl, lcStr, lcTo)
	replace newText with ;
		rtrim(newText) + ;
		iif(lnx<>1, chr(13), '') + ;
		lcRepl
	lnLineNo = lnLine
ELSE
	*-- Save end of program object
	select ac_work
	lnLineNo = lnLineNo + 1
	FOR lnx = lnLineNo TO memlines(text)
		replace newText with ;
					rtrim(newText) + ;
					iif(lnx<>1, chr(13), '') + ;
					mline(text, lnx)
	ENDFOR
ENDIF

RETURN

*-- ***********************************************
*-- ***********************************************
*-- Do all of the replaces in one File of "Objects"
PROCEDURE l_ReplObject

*-- Use object file
use (lcFile) alias ObjectFile IN 0

*-- Backup?
SELECT ObjectFile
if llBackup
	copy to &lcToFile.
ENDIF

*-- Now run through this entire object FILE
lnRecno   = 0			&& Last Record processed
lcObjItem = " "			&& Last Object Processed
lnLineNo  = 0			&& For scope
SELECT ac_updated
SCAN FOR fname = lcFile
	*-- New Object or Object Record?
	lcChkItem = l_objItem(object)
	IF lcObjItem <> lcChkItem	OR ;
	   lnRecno   <> objrec

		*-- Have worked on an object yet?
		IF ! EMPTY(lcObjItem)
			*-- Copy the rest to ac_work.newtext
			*--				from ac_work.text
			DO l_replone WITH 2
			*-- Update objects item
			SELECT objectfile
			replace &lcObjItem. with ac_work.newtext
			SELECT ac_updated
		ENDIF

		*-- Setup new fields
		lnRecno   = objrec
		lcLastObj = object
		lcObjItem = l_objItem(object)

		*-- Do we still have this object in the file?
		SELECT ObjectFile
		if type("&lcObjItem.") <> "U"
			*-- Go To record in Objectfile
			GOTO lnRecno
  			*-- Fill work memo file with object memo fld
  			SELECT ac_work
			replace text    WITH ObjectFile.&lcObjItem., ;
					newtext WITH ""
			lnLineNo = 0	&& Reset Line Counter for this fld
		ENDIF
	ENDIF

	*-- Display Progress
	wait window "Update " + lcfile + CHR(13) + ;
				lcObjItem + " Object"	nowait

	*-- Fill fields 
	SELECT ac_updated
	lcString = alltrim(string)
	lnString = len(lcString)
	lcTo     = alltrim(newstring)
	lnTo	 = len(lcTo)
	lnLine   = val(lineno)
	*-- Replace one text line
	DO l_replone WITH 1
	
	SELECT ac_updated
ENDSCAN

*-- ********************************
*-- Copy the rest to ac_work.newtext
*--				from ac_work.text
*-- FOR Last Item!
IF ! EMPTY(lcObjItem)
	DO l_replone WITH 2
	*-- Update objects item
	SELECT objectfile
	replace &lcObjItem. with ac_work.newtext
ENDIF

USE IN SELECT('ObjectFile')

RETURN

*-- **************************
*-- *** Misc Utility Procs ***
*-- **************************
*-- Create Backup Subdirectory
procedure l_makebak
parameter llB

if llB
	lcError = on('error')
	on error do l_makerr
	lcBackDir = IIF(EMPTY(gHomeDir), sys(5) + curdir(), gHomeDir) + ;
				'Backup\'
	mkdir &lcBackDir.
	on error &lcError.
endif

return


*-- Trap error and return
procedure l_makerr

on error
return


*-- *********************************
*-- Return Item Type for object fixes
procedure l_objItem
parameter lcObjDesc

do case
	case empty(lcObjDesc)
		return("X")
	case "procedure" 	$ LOWER(lcObjDesc)
		return("Procedure")
	case "methods" 		$ LOWER(lcObjDesc)
		return("Methods")
	case "properties" 	$ LOWER(lcObjDesc)
		return("Properties")
	case "supexpr" 		$ LOWER(lcObjDesc)
		return("Supexpr")
	case "expr" 		$ LOWER(lcObjDesc)
		return("Expr")
	case "prompt" 		$ LOWER(lcObjDesc)
		return("Prompt")
	case "command" 		$ LOWER(lcObjDesc)
		return("Command")
	case "field" 		$ LOWER(lcObjDesc)
		return("expr")
	case "print when" 	$ LOWER(lcObjDesc)
		return("supexpr")
	case "message" 		$ LOWER(lcObjDesc)
		return("message")
	case "setup" 		$ LOWER(lcObjDesc)
		return("setup")
	case "cleanup" 		$ LOWER(lcObjDesc)
		return("cleanup")
	case "skipfor" 		$ LOWER(lcObjDesc)
		return("skipfor")
endcase

return ("X")

*-- ****************************************
*-- Set flag = either ASCII or dbf type file
procedure l_objType
parameter lcF
lcChkr = lower(lcF)
if ".spr" $ lcChkr		or ;
   ".prg" $ lcChkr
	return(.t.)
else
	return(.f.)
endif

return (.f.)

