*-- VFP 6.0 Version -- Check Code for String(s) Program
*--
*PARAMETER lcstring, lcfname, llcomment, llclasses
modify window screen title "ChkStr - Powerful, Wonderful String Check Utility"
*hide window screen

clear
close all
set exclusive on
set safety off
set delete on
set memowidth to 254
SET PROCEDURE TO chkproc.prg

public gnstop, gnquestion, gnexclaim, gninfo
public gnok, gnokcanc, gnabretign, gnyesnocan, gnyesno
public gldevelop, gcOldEscape, gcCrLf
gcCrLf = CHR(13)

*-- Not In developer - Production Version
gldevelop = .f.

*-- Message Box Variables (2/28/97)
*-- Symbol
gnstop    = 16	&& Stop Sign
gnquestion= 32	&& Question Mark
gnexclaim = 48	&& Exclamation Mark
gninfo    = 64	&& Information (i)
*-- 			   Buttons			   Returns
gnok	  = 0	&& OK					1
gnokcanc  = 1	&& OK/Cancel			1/2
gnabretign= 2	&& Abort/Retry/Ignore	3/4/5
gnyesnocan= 3	&& Yes/No/Cancel		6/7/2
gnyesno   = 4	&& Yes/No				6/7
*-- (Add symbol to Button to get boxtype and response type)
*-- Example:	=MSGBOX("Stop and OK", "", gnstop+gnok)

public gcfname, gHomeDir, glreport, gcoutfile, glwait
public lastring(1), gnnextrept, gcVersion, gcCopyRight
public gnorder, glcomment, glclasses, gllist, gcinfo, glMaxFrame
public gcSaveOut
*-- 4/2/01 - New option, Preserve Case on input/scans
*--	4/10/01 - allow ascii
*-- 4/16/01 - Allow option on highlighting
public glCase, glAscii, glHighLight
glCase = .f.				&& Don't Preserve Case
glAscii= .f.				&& Don't allow ASCII
glHighLight = .t.			&& Highlight results
*--	End of Change CVG
gcoutfile = " "
gcSaveOut = " "

*-- Flag: Save all code in a table/file - CVG - 10/7/2002
public glSaveSource, glSelSource, gnSaveFound, glFoundString
public gcSaveFile, gcSaveObj, gcSaveCodIn, glOccurences, gnOccurs
glSaveSource = .f.		&& Save Source Flag
glSelSource  = .f.		&& Select which source to save Flag
gnSaveFound  = 1		&& If   1) glSelSource=.f.   2) glSelSource=.t.
glFoundString = .f.		&& Found string in file - for SaveFound
gcSaveFile   = " "		&& Save Last Filename for Save Source
gcSaveObj    = " "		&& Save last object name for Save Source
gcSaveCodIn  = " "		&& Output file for Source
glOccurences = .t.		&& Count number of occurences of string(s)
gnOccurs = 0			&& Counter for same

*-- Fill parameters from Default File
do l_parafill

*-- ***************************************
*-- ***************************************
*-- Loop Back to Run Again!!!  6/1/99 - CVG
do while .t.

	*-- Not Called with a string, get it with ChkGet Screen
	lastring(1) = " "

	*-- Set escape to exit from forms, run main form
	gcOldEscape = on('key','ESC')
	on key label escape _Screen.activeform.CmdExit.click
	set escape on
	do form chkget

	*-- Reset escape
	on key label ESCAPE &gcOldEscape.

	*-- User wants to exit
	if lastring(1) = "<<<EXIT>>>"
		do l_locate				&& Locate on first chkreptxx found
		wait window "Chkstr Cancelled!" nowait
		do l_cleanup
		show window screen
		cancel
	endif

	*-- Get number of Strings Entered
	lnstr = alen(lastring)

	*-- Create Cursors for reporting and filenames
	create cursor ac_report (;
		filename M, 		fill1 C(1), ;
		object   C(120),	fill2 C(1), ;
		lineno   C(5), 		fill3 C(2), ;
		text     C(254), 	recno N(10), ;
		count	 N(10),		string C(200))

	create cursor ac_files (FileName M, type C(1), Source L)

	*-- If called with a project filename, fill from project
	if upper(right(alltrim(gcfname),4)) == '.PJX'
		use (gHomeDir+gcfname) alias project in 0
		select project
		locate for type == 'H'
		gHomeDir = alltrim(iif(found(), chrtran(homedir, chr(0), ""), ""))
		gHomeDir = gHomeDir + iif(empty(gHomeDir), '', '\')
		scan for type!='H' and type < 'Z'
			append blank in ac_files
			cFilename = alltrim(chrtran(strtran(project.name, ".mnx", ".mpr"), chr(0), ""))
			replace ;
				ac_files.filename with cFileName, ;
				ac_files.type 	  with type, ;
				ac_files.source   with .f.
		endscan
		use in project
	else
		*-- Fill from ASCII text file
		*-- Fill intermediate file first
		create cursor ac_temp (type C(1), filename C(254))
		append from (gHomeDir+gcfname) sdf

		*-- Do we have a Home Directory record in text file
		locate for type == "H"
		if found()
			*-- Replace Default home directory
			gHomeDir = iif(found(), alltrim(filename), "")
			gHomeDir = gHomeDir + iif(empty(gHomeDir), '', ;
				iif(right(gHomeDir, 1) <> '\', '\', ""))
			delete for type == "H"
		endif

		*-- Now load up filename cursor from temp file
		scan for ! empty(type)
			select ac_files
			append blank
			replace type     with ac_temp.type, ;
					filename with ac_temp.filename, ;
					source	 with .f.
			select ac_temp
		endscan
		use in ac_temp
	endif

	*-- Setup report variables
	lctitle = "Check for String(s) in " + alltrim(gcfname)
	lcstring = ""
	for lnx = 1 to alen(lastring)
		lcstring = iif(empty(lcstring), "'", lcstring + ", '") + ;
			alltrim(lastring(lnx)) + "'"
	endfor

	if ! glwait
		activate screen
	endif

	*-- For new special type - Table of Memo Field
	dimension lcMField(1)
	lnMField = 0

	*-- Adjust string array into lcst array (4/10/01 - for glascii)
	*--		This also adjusts the strings just once instead of each check!
	dimension lcst(1)
	do l_adjstr

	*-- ********************************
	*-- If needed, table for Source code
	=ChkSaveSource()

	*-- ***********************************
	*-- ***********************************
	*-- 			THE BIG LOOP!
	*-- ***********************************
	*-- ***********************************
	*--  Now go through the Project's File
	select ac_files

	scan
		*
		*-- Misc. Type - Memo field name to check?
		if type = "*"
			if empty(ac_files.filename)
				*-- Reset field list
				lnMField = 0
				dimension lcMField(lnMField)
				lcMField = ""
			else
				*-- Add a field to memo field list
				lnMField = lnMField + 1
				dimension lcMField(lnMField)
				lcMField(lnMField) = alltrim(ac_files.filename)
			endif
			loop
		endif

		lcfile = gHomeDir + alltrim(filename)

		*-- Display Progress
		if glwait
			wait clear
			wait window "Checking " + lcfile nowait
		else
			? lcfile
		endif

		*-- Set temp type and save source vars.
		lctype = type
		glSaveSource = source

		do case
			*-- Ok, Check whether Object file exists
			case ! file("&lcfile.")
				select ac_report
				append blank
				replace filename with lcfile, ;
						text	 with "File not Found!"

				*-- .PRG or .SPR (Programs/2.6 Screens)
			case type = "P" or type = "E" or type = "S"
				lcfile = strtran(upper(lcfile), ".SCX", ".SPR")
				do l_scanprg
				*-- .SCX (Screens)
			case type = "K"
				do l_scanscx
				*-- .FRX or .LBX (Report/Label Forms)
			case type = "R" or type = "B"
				do l_scanfrx
				*-- .MPR (Menu)
			case type = "M"
				do l_scanmpr
				*-- .VCX (Class Library)
			case type = "V" and glclasses and ;
					! ("\X3" $ upper(lcfile)  and ".VCX" $ upper(lcfile))
				do l_scanvcx
				*-- .VCX (Class Library in Visual Max Frame)
			case type = "V" and glMaxFrame and ;
					"\X3" $ upper(lcfile)  and ".VCX" $ upper(lcfile)
				do l_scanvcx
			case type = "V"
				*-- Bypass Class Library if flag not on
			case type = "L"
				*-- Bypass Foxpro 2.6 Libraries
			case type = "D"
				*-- Bypass Databases and Tables
			case type = "C" and ;
					lnMField = 0
				select ac_report
				append blank
				replace filename with lcfile, ;
						text	 with "No Memo Fields to Check!"
			case type = "C"
				*-- Misc. type -- Special for check memo field in table
				do l_scanmisc
			otherwise
				*-- Don't Know...Tell 'Em
				select ac_report
				append blank
				replace filename with lcfile, ;
						text	 with "File Type '" + ac_files.type + "' not Valid!"
		endcase
		select ac_files
	endscan
	*-- ************************************
	*-- ************************************
	*-- 		END OF THE BIG LOOP
	*-- ************************************
	*-- ************************************

	wait clear
	show window screen top

	*-- ************************************
	*-- Check whether any we have any output
	*-- ************************************
	DO ChkFinish

	*-- Refill Parameters
	do l_parafill
enddo			&& End of Loop Back - CVG - 6/1/99

do l_cleanup

return
