
*-- Protected USE/Use In
PROCEDURE g_use
PARAMETERS tcFile, tcOrder, tlClose, tlExclusive

*-- Just use in?
IF tlClose
	IF USED(tcFile)
		USE IN (tcFile)
	ENDIF
	lRetn = .t.
ELSE
	lRetn = g_use(tcFile, tcOrder, tlExclusive)
ENDIF

RETURN (lRetn)

*-- ********************************
*-- Provisional Open -
*--		If not open already, open it
*-- 	Return with table selected
*--
*-- tcTable = table name
*-- tcTag   = Tag to set (or "" for none)
*--	tcExcl  = .t. open exclusive
PROCEDURE g_open
PARAMETERS tcTable, tcTag, tcExcl

gnAns = 6
lnTryCount = 0

*-- Set error trap for opening
lcError = ON('error')
ON ERROR DO l_cantget with ERROR(), PROGRAM(), MESSAGE()

*-- As long as they want to retry
DO WHILE gnAns = 6
	lnTryCount = lnTryCount + 1
	IF USED(tcTable)
		IF tcExcl
			*-- Going to open exclusive, close it
			USE IN (tcTable)
		ELSE
			*-- Going to select it standard, just return
			SELECT (tcTable)
			IF ! EMPTY(tcTag)
				SET ORDER TO &tcTag.
			ENDIF
			ON ERROR &lcError.
			RETURN (.T.)
		ENDIF
	ENDIF

	*-- Try to open in new workarea
	SELECT 0
	IF tcExcl
		USE (tcTable) EXCLUSIVE
	ELSE
		USE (tcTable)
	ENDIF

	*-- Succeeded, return .t., reset error
	IF USED(tcTable)
		IF ! EMPTY(tcTag)
			SET ORDER TO &tcTag.
		ENDIF
		ON ERROR &lcError.
		RETURN (.T.)
	ENDIF
ENDDO

*-- Gave up, reset error, return .f.
ON ERROR &lcError.

RETURN (.F.)

*-- ******************************
*-- Can't get exclusive use or
*-- Someone else has exclusive use
PROCEDURE l_cantget
PARAMETERS lnError, lcProgram, lcMessage

IF tcExcl
	lcMessage = "Cannot get exclusive use of " + ALLTRIM(tcTable) + CHR(13) + ;
		"Try to get other users to leave the system."
ELSE
	lcMessage = "Someone else has exclusive use of " + ALLTRIM(tcTable) + CHR(13) + ;
		"you cannot continue at this time."
ENDIF
gnAns = MESSAGEBOX(lcMessage + CHR(13) + CHR(13) + ;
	IIF(lnTryCount=1,"Retry?", ;
	"Tried " + ALLTRIM(STR(lnTryCount)) + ;
	" times, try again?"), 20)

RETURN

*-- Clean up files - CVG - 10/14/2002
procedure l_cleanup

lny=0
for lnx = 1 to 20
	select (lnx)
	if ! left(alias(), 7) $ "CHKREPT|CHKSAVE"
		use
	else
		lny = iif(lny=0, lnx, lny)
	endif
endfor


return
