*-- Setup for chkview.scx form
*-- Make View Driver cursor/read-write
=afields(latemp)
create cursor ac_view from array latemp
*-- Ac_tmpr and lnReport set in chgbrowse.prg
append from dbf('ac_tmpr') for rptfile = lnReport
index on rptfile tag rptfile

scan
	lnRpt = rptfile
	lcStr = ""
	select ac_cstrin
	scan for rptfile = lnRpt
		lcStr = lcStr + ;
				iif(empty(lcStr), "", ", ") + ;
				alltrim(texts)
	endscan
	select ac_view
	replace texts with lcStr
endscan

*-- Build results viewing table
lcMissing = ""
select ac_view
scan
	lcFile = alltrim(outfile)
	if ! file(lcFile + '.dbf')
		lcMissing = lcMissing + ;
					iif(empty(lcMissing), "", chr(13)) + ;
					lcFile
	else
		*-- Select chkreptxxx contents
		select lineno, ;
			   object, ;
			   text, ;
			   string, ;
			   fname, ;
			   space(20) as filename, ;
			   ac_view.outfile as outfile ;
		  from (lcFile) ;
		  into cursor ac_tmp2

		*-- Already built viewer file?
		if ! used('ac_text')
			=afields(latemp)
			create cursor ac_text from array latemp
		else
			select ac_text
		endif
		append from dbf('ac_tmp2')
		use in ac_tmp2
		use in (lcFile)
	endif
	select ac_view
endscan

*-- No files - No results
if ! used('ac_text')
	=messagebox("Sorry, there were no ChkStr results files available to view" + chr(13) + ;
				"Perhaps they were deleted?", 16)
	return
endif

*-- Missing Files
if ! empty(lcMissing)
	=messagebox("There were ChkStr results files missing." + chr(13) + ;
				lcMissing + chr(13) + ;
				"Perhaps they were deleted?", 16)
endif

*-- Filenames and Indices
select ac_text
replace all filename with upper(alltrim(right(fname, len(fname)-rat('\', fname))))
index on outfile tag outfile

*-- Set relation
select ac_view
set relation to outfile into ac_text
go top
